#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_RobotNameCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_RobotNameCFG> M_RobotNameCFG::msSingleton(nullptr);

int M_RobotNameCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RobotNameCFGData* M_RobotNameCFG::GetData(int index)
{
	auto it = mMapData.find(index);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_RobotNameCFGData>& M_RobotNameCFG::GetMapData()
{
	return mMapData;
}

void M_RobotNameCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_RobotNameCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RobotNameCFGData data;
		data.mindex = element->IntAttribute("index");
		data.mNickName = element->Attribute("NickName");
		data.mPlayerId = element->IntAttribute("PlayerId");
		data.mVip = element->IntAttribute("Vip");
		data.mHead = element->IntAttribute("Head");
		data.mHeadFrame = element->IntAttribute("HeadFrame");
		data.mGold = element->IntAttribute("Gold");
		data.mTurretID = element->IntAttribute("TurretID");
		data.mWingID = element->IntAttribute("WingID");
		{
			const char* Items = element->Attribute("Items");
			std::vector<std::string> vecItems;
			boost::split(vecItems, Items, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItems[i].c_str(), &temp))
				{
					data.mItems.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mindex) != mMapData.end())std::cout <<"data refind:" << data.mindex << std::endl;
		assert(mMapData.find(data.mindex) == mMapData.end());
		mMapData.insert(std::make_pair(data.mindex, data));
		element = element->NextSiblingElement();
	}
}

void M_RobotNameCFG::Load()
{
	Load("../Config/M_RobotNameCFG.xml");
}

M_RobotNameCFG* M_RobotNameCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RobotNameCFG());
	}
	return msSingleton.get();
}
